/*****************************************************************************
  FILE           : $Source: /usr/local/bv/SNNS/SNNSv4.1/rpc/sources/RCS/ui_rpc.ph,v $
  SHORTNAME      : ui_rpc.ph
  SNNS VERSION   : 4.1

  PURPOSE        : private header for ui_rpc.ph
  NOTES          :

  AUTHOR         : Sven Doering
  DATE           : 

  CHANGED BY     : 
  IDENTIFICATION : $State: Exp $ $Locker:  $
  RCS VERSION    : $Revision: 1.6 $
  LAST CHANGE    : $Date: 1995/11/16 07:27:39 $

             (c) 1994 by Sven Doering and the SNNS-Group

******************************************************************************/

#ifndef _UI_RPC_DEFINED_
#define _UI_RPC_DEFINED_

/* begin global definition section */

void ui_RPCQuit(void);
int ui_initRPC(void);
void ui_xCreateRPCPanel(Widget ui_RPCBox) ;

Bool forcePortmapper = FALSE;           
Bool ui_RPCIsCreated = FALSE; 		/* RPC panel created yes or no */
Bool ui_RPCServerIsCreated = FALSE; 	/* RPC Server panel created yes or no */
Bool ui_RPCSetupIsCreated = FALSE; 	/* RPC Setup panel created yes or no */
Widget ui_RPCPanel;
Widget ui_RPCServerPanel,ui_popRPCServer;
Widget RPCBox, RPCHostList,RPCServerList, ui_hostname,ui_RPCItemsDesc;
Widget ui_servername,ui_path,ui_parameter;
Widget ui_RPCSetupPanel,ui_popRPCSetup;
Widget ui_RPCUDPtoggle,ui_RPCTCPtoggle;
Widget ui_RPCNormalToggle,ui_RPCCoop_M_Toggle;
Widget ui_RPCtimeout_sec,ui_RPCtimeoutlong_sec,ui_RPCexittimeout_min;
Widget ui_RPCswitchtolocalall,ui_RPCswitchtolocalsingle;

/* end global definition section */

/* begin private definition section */

#define RPC_DONE 0
#define RPC_APPLY 1
#define RPC_DEFAULT 2
#define RPC_UDP 3
#define RPC_TCP 4
#define RPC_NORMAL 5
#define RPC_COOP_MASTER 6
#define RPC_COOP_SLAVE 7

static void ui_xCreateRPCServerPanel (Widget parent);
static void ui_displayRPCServerPanel (Widget w, Widget button, caddr_t call_data);
static void ui_RPCselectionCallback(Widget w,caddr_t client_data,XawListReturnStruct *selektion);
static void ui_RPCshutdownCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCinfoCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCnewCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCswitchtoCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCSetupCallback(Widget w, int button, caddr_t selektion);
static void ui_RPCServerSelectionCallback(Widget w,caddr_t client_data,XawListReturnStruct *selektion);
static void ui_RPCServerCreateCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCServerReconnectCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_RPCServerBroadcastCallback(Widget w,caddr_t client_data,caddr_t selektion);
static void ui_xCreateRPCSetupPanel(Widget parent);
static void ui_displayRPCSetupPanel(Widget w, Widget button, caddr_t call_data);

#ifdef __linux__
static int sigtermcallback(int sig, int code,const struct sigaction * scp, struct sigaction *addr);
static int sigalarmcallback(int sig, int code, const struct sigaction * scp, struct sigaction *addr);
static int sigpipecallback(int sig, int code,const struct sigaction * scp, struct sigaction *addr);
#else
static void sigpipecallback(int sig, int code, struct sigcontext * scp, char *addr);
static void sigtermcallback(int sig, int code, struct sigcontext * scp, char *addr);
static void sigalarmcallback(int sig, int code, struct sigcontext * scp, char *addr);
#endif


/* end private definition section */
#endif /* UI_RPC */






