/*****************************************************************************
  FILE           : $Source: /usr/local/bv/SNNS/SNNSv4.1/tools/sources/RCS/batchman.ph,v $
  SHORTNAME      : batchman
  SNNS VERSION   : 4.1

  PURPOSE        : SNNS batch interpreter main module
                   initialization, command line argument handling, main()
  NOTES          : 

  AUTHOR         : Jens Wieland
  DATE           : 

  CHANGED BY     : 
  IDENTIFICATION : $State: Exp $ $Locker:  $
  RCS VERSION    : $Revision: 1.1 $
  LAST CHANGE    : $Date: 1995/07/03 10:14:14 $

             Copyright (c) 1990-1995  SNNS Group, IPVR, Univ. Stuttgart, FRG

******************************************************************************/

#ifndef _BATCHMAN_DEFINED_
#define _BATCHMAN_DEFINED_

/* begin global definition section */

FILE *log_file;                  /* file pointer of log file */

int input_is_file;               /* global flag to notify the scanner
			            not to print batchman> every line */

int warn_flag,                   /* flag not to print warnings if set */
    message_flag;                /* flag not to print messages if set */

/* end global definition section */


/* begin private definition section */

static void print_help(void);
static void read_cmdline(int argc, char **argv);
static void open_files(void);

static char *input_file_name = NULL;  /* file name of user program */
static char *log_file_name = NULL;    /* file name of log file */

static int parse_only_flag = 0;       /* store parse-only mode */

/* end private definition section */

#endif
