/*****************************************************************************
  FILE           : $Source: /usr/local/bv/SNNS/SNNSv4.1/tools/sources/RCS/snns_intfce.ph,v $
  SHORTNAME      : snns_intfce
  SNNS VERSION   : 4.1

  PURPOSE        : Interface between Batchman's jacket function calls (via 
                   the symbol table) and SNNS-kernel calls

  NOTES          : This file is provided for future extensions of Batchman
                   and has *no semantic purpose* in this version. The 
                   intention is to set up a clearly defined entry point 
                   between the batch language processing and the SNNS-kernel. 
                   Instead of adressing the kernel, XGUI callback
                   functions can be executed from here.

  AUTHOR         : Jens Wieland
  DATE           : 

  CHANGED BY     : 
  IDENTIFICATION : $State: Exp $ $Locker:  $
  RCS VERSION    : $Revision: 1.3 $
  LAST CHANGE    : $Date: 1995/07/20 07:52:58 $

             Copyright (c) 1990-1995  SNNS Group, IPVR, Univ. Stuttgart, FRG

******************************************************************************/

#ifndef _SNNS_INTFCE_DEFINED_
#define _SNNS_INTFCE_DEFINED_

/* begin global definition section */

void int_setInitFunc(arglist_type *arglist);
void int_setLearnFunc(arglist_type *arglist);
void int_setUpdateFunc(arglist_type *arglist);
void int_setPruningFunc(arglist_type *arglist);
void int_setSubPattern(arglist_type *arglist);
void int_setShuffle(arglist_type *arglist);
void int_setSubShuffle(arglist_type *arglist);
void int_setParallelMode(arglist_type *arglist);
void int_setCascadeParams(arglist_type *arglist);

void int_initNet(arglist_type *arglist);
void int_loadNet(arglist_type *arglist);
void int_saveNet(arglist_type *arglist);
void int_saveResult(arglist_type *arglist);
void int_trainNet(arglist_type *arglist);
void int_testNet(arglist_type *arglist);
void int_pruneNet(arglist_type *arglist);
void int_pruneTrainNet(arglist_type *arglist);
void int_pruneNetNow(arglist_type *arglist);
void int_delCandUnits(arglist_type *arglist);

void int_loadPattern(arglist_type *arglist);
void int_setPattern(arglist_type *arglist);
void int_delPattern(arglist_type *arglist);

void int_setSeed(arglist_type *arglist);

/* end global definition section */

/* begin private definition section */

/* end private definition section */

#endif
